﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.Misc;

namespace MaintainDropDownButtonApprnce99351
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            this.Load += new EventHandler(Form1_Load);
        }

        void Form1_Load(object sender, EventArgs e)
        {
            //ultraDropDownButton1.appearance = ultraDropDownButton1.HotTrackAppearance;

            Infragistics.Win.Appearance dropDownButtonAppearance = (Infragistics.Win.Appearance)ultraDropDownButton1.HotTrackAppearance;
            //ultraDropDownButton1.Appearances.Add(dropDownButtonAppearance);
            ultraDropDownButton1.Appearance = dropDownButtonAppearance;

            //Set the UltraDropDownButton's DrawFilter to a new instance of our custom draw filter 
            ultraDropDownButton1.DrawFilter = new UltraDropDownButtonDrawFilter();
        }
    }

    public class UltraDropDownButtonDrawFilter : IUIElementDrawFilter
    {
        public Infragistics.Win.DrawPhase GetPhasesToFilter(ref Infragistics.Win.UIElementDrawParams drawParams)
        {
            if (drawParams.Element is SplitButtonUIElement ||
                drawParams.Element is SplitButtonDropDownUIElement)
            {
                return DrawPhase.AfterDrawTheme;
            }

            return DrawPhase.None;
        }

        public bool DrawElement(Infragistics.Win.DrawPhase drawPhase, ref Infragistics.Win.UIElementDrawParams drawParams)
        {
            // we want to draw after the element has drawn the theme phase
            // since cancelling the before draw theme will have the elemnt 
            // draw as unthemed
            if (DrawPhase.AfterDrawTheme == drawPhase)
            {
                // get the button element
                ButtonUIElementBase buttonElement = drawParams.Element as ButtonUIElementBase;

                if (null != buttonElement)
                {
                    // get the button control and current button state
                    UltraDropDownButton dropDown = drawParams.ControlElement.Control as UltraDropDownButton;
                    UIElementButtonState buttonState = buttonElement.ButtonState;

                    // see if we have 2 buttons or just one main button
                    bool hasSeparateSplitButton = dropDown.Style == SplitButtonDisplayStyle.SplitButton;

                    // we only want to render the button when the mouse is not
                    // down or over on either button element and when the button
                    // is not dropped down.
                    if (dropDown.IsDroppedDown == false && buttonElement.IsMouseOver == false)
                    {
                        bool renderButton = true;

                        // if there are 2 button elements then only 
                        // render this one as mouse over if neither 
                        // is down
                        if (hasSeparateSplitButton)
                        {
                            ButtonUIElementBase otherButtonElement = drawParams.Element.Parent.GetDescendant(
                                drawParams.Element is SplitButtonUIElement ? typeof(SplitButtonDropDownUIElement) : 
                                typeof(SplitButtonUIElement)) as ButtonUIElementBase;

                            if (buttonElement.IsMouseDown == false && otherButtonElement.IsMouseDown == false)
                                buttonState |= UIElementButtonState.MouseOver;
                            else
                                renderButton = false;
                        }

                        if (renderButton)
                        {
                            XPThemes.ToolBar.DrawToolbarButton(
                                hasSeparateSplitButton,
                                !hasSeparateSplitButton ||
                                drawParams.Element is SplitButtonDropDownUIElement,
                                buttonState,
                                ref drawParams,
                                drawParams.Element.Rect,
                                drawParams.InvalidRect);
                        }
                    }
                }
            }

            return false;
        }

    }
}
